## McdChannel McdChannel — Channel class representing Telepathy channel class |

## Stability Level

Unstable, unless otherwise indicated

## Synopsis

    #include <mcd-channel.h>

                        McdChannel;
    enum                McdChannelStatus;
    McdChannelStatus    mcd_channel_get_status              (McdChannel *channel);
    gboolean            mcd_channel_get_members_accepted    (McdChannel *channel);
    const gchar*        mcd_channel_get_channel_type        (McdChannel *channel);
    GQuark              mcd_channel_get_channel_type_quark  (McdChannel *channel);
    const gchar*        mcd_channel_get_object_path         (McdChannel *channel);
    guint               mcd_channel_get_handle              (McdChannel *channel);
    TpHandleType        mcd_channel_get_handle_type         (McdChannel *channel);
    const gchar *       mcd_channel_get_name                (McdChannel *channel);
    gboolean            mcd_channel_is_requested            (McdChannel *channel);
    McdAccount *        mcd_channel_get_account             (McdChannel *channel);

## Object Hierarchy

      GObject
       +----McdMission
             +----McdChannel

## Implemented Interfaces

McdChannel implements TpSvcChannelRequest and TpSvcDBusProperties.

## Properties

      "account-path"             DBusGObjectPath*      : Read
      "interfaces"               GStrv*                : Read
      "outgoing"                 gboolean              : Read / Write / Construct Only
      "preferred-handler"        gchar*                : Read
      "requests"                 GPtrArray_GHashTable_gchararray+GValue__*  : Read
      "tp-channel"               TpChannel*            : Read / Write / Construct
      "user-action-time"         gint64                : Read

## Signals

      "members-accepted"                               : Run First
      "status-changed"                                 : Run First

## Description

FIXME

## Details

### McdChannel

    typedef struct _McdChannel McdChannel;

### enum McdChannelStatus

    typedef enum
    {
        MCD_CHANNEL_STATUS_UNDISPATCHED, /* used for channels created in the
                                            NewChannel signal before the connection
                                            is ready */
        MCD_CHANNEL_STATUS_REQUEST,      /* Telepathy channel is not yet created */
        MCD_CHANNEL_STATUS_REQUESTED,    /* Channel has been requested from the CM
                                          */
        MCD_CHANNEL_STATUS_DISPATCHING,  /* Telepathy channel is created and
                                            waiting dispatch */
        MCD_CHANNEL_STATUS_HANDLER_INVOKED,
        MCD_CHANNEL_STATUS_DISPATCHED,   /* Channel has been dispatched to handler
                                          */
        MCD_CHANNEL_STATUS_FAILED,       /* Channel creation failed, or channel
                                            could not be dispached to a handler */
        MCD_CHANNEL_STATUS_ABORTED,      /* Channel has been aborted */
    } McdChannelStatus;

### mcd_channel_get_status ()

    McdChannelStatus    mcd_channel_get_status              (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_members_accepted ()

    gboolean            mcd_channel_get_members_accepted    (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_channel_type ()

    const gchar*        mcd_channel_get_channel_type        (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_channel_type_quark ()

    GQuark              mcd_channel_get_channel_type_quark  (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_object_path ()

    const gchar*        mcd_channel_get_object_path         (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_handle ()

    guint               mcd_channel_get_handle              (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_handle_type ()

    TpHandleType        mcd_channel_get_handle_type         (McdChannel *channel);

`channel` : |
Returns : |

### mcd_channel_get_name ()

    const gchar *       mcd_channel_get_name                (McdChannel *channel);

Get the Telepathy name of `channel` (calls InspectHandles on the channel handle).

`channel` : | the McdChannel.
Returns : | a const string holding the channel name.

### mcd_channel_is_requested ()

    gboolean            mcd_channel_is_requested            (McdChannel *channel);

`channel` : | the McdChannel.
Returns : | `TRUE` if `channel` was requested, `FALSE` otherwise.

### mcd_channel_get_account ()

    McdAccount *        mcd_channel_get_account             (McdChannel *channel);

`channel` : | the McdChannel.
Returns : | the McdAccount on which this channel was created.

## Property Details

### The `"account-path"` property

      "account-path"             DBusGObjectPath*      : Read

Object path of the Account.

### The `"interfaces"` property

      "interfaces"               GStrv*                : Read

A dbus-glib 'as'.

### The `"outgoing"` property

      "outgoing"                 gboolean              : Read / Write / Construct Only

True if the channel was requested by us.

Default value: FALSE

### The `"preferred-handler"` property

      "preferred-handler"        gchar*                : Read

Well-known bus name of the preferred Handler.

Default value: NULL

### The `"requests"` property

      "requests"                 GPtrArray_GHashTable_gchararray+GValue__*  : Read

A dbus-glib aa{sv}.

### The `"tp-channel"` property

      "tp-channel"               TpChannel*            : Read / Write / Construct

Telepathy Channel.

### The `"user-action-time"` property

      "user-action-time"         gint64                : Read

Time of user action in seconds since 1970.

Default value: 0

## Signal Details

### The `"members-accepted"` signal

    void                user_function                      (McdChannel *mcdchannel,
                                                            gpointer    user_data)       : Run First

`mcdchannel` : | the object which received the signal.
`user_data` : | user data set when the signal handler was connected.

### The `"status-changed"` signal

    void                user_function                      (McdChannel *mcdchannel,
                                                            gint        arg1,
                                                            gpointer    user_data)       : Run First

`mcdchannel` : | the object which received the signal.
`arg1` : |
`user_data` : | user data set when the signal handler was connected.